package com.sun.org.apache.bcel.internal.generic;

import com.sun.org.apache.bcel.internal.Const;
import com.sun.org.apache.bcel.internal.classfile.ConstantPool;

public abstract class FieldInstruction extends FieldOrMethod
{
    FieldInstruction() {
    }
    
    protected FieldInstruction(short opcode, int index) {
        super(opcode, index);
    }
    
    @Override
    public String toString(ConstantPool cp) {
        return Const.getOpcodeName((int)super.getOpcode()) + " " + cp.constantToString(super.getIndex(), (byte)9);
    }
    
    protected int getFieldSize(ConstantPoolGen cpg) {
        return Type.size(Type.getTypeSize(this.getSignature(cpg)));
    }
    
    @Override
    public Type getType(ConstantPoolGen cpg) {
        return this.getFieldType(cpg);
    }
    
    public Type getFieldType(ConstantPoolGen cpg) {
        return Type.getType(this.getSignature(cpg));
    }
    
    public String getFieldName(ConstantPoolGen cpg) {
        return this.getName(cpg);
    }
}
